diff --git a/testsuite/test-blacklist.c b/testsuite/test-blacklist.c
index d03eedb..6531fa2 100644
--- a/testsuite/test-blacklist.c
+++ b/testsuite/test-blacklist.c
@@ -96,7 +96,7 @@ fail_lookup:
 
 DEFINE_TEST(blacklist_1,
 #if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
+	.skip = true,
 #endif
 	.description = "check if modules are correctly blacklisted",
 	.config = {
diff --git a/testsuite/test-depmod.c b/testsuite/test-depmod.c
index 6465230..010f259 100644
--- a/testsuite/test-depmod.c
+++ b/testsuite/test-depmod.c
@@ -41,9 +41,6 @@ static noreturn int depmod_modules_order_for_compressed(const struct test *t)
 }
 
 DEFINE_TEST(depmod_modules_order_for_compressed,
-#if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
-#endif
 	.description = "check if depmod let aliases in right order when using compressed modules",
 	.config = {
 		[TC_UNAME_R] = MODULES_ORDER_UNAME,
@@ -75,9 +72,6 @@ static noreturn int depmod_modules_outdir(const struct test *t)
 }
 
 DEFINE_TEST(depmod_modules_outdir,
-#if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
-#endif
 	.description = "check if depmod honours the outdir option",
 	.config = {
 		[TC_UNAME_R] = MODULES_OUTDIR_UNAME,
@@ -104,6 +98,9 @@ static noreturn int depmod_search_order_simple(const struct test *t)
 	exit(EXIT_FAILURE);
 }
 DEFINE_TEST(depmod_search_order_simple,
+#if defined(KMOD_SYSCONFDIR_NOT_ETC)
+	.skip = true,
+#endif
 	.description = "check if depmod honor search order in config",
 	.config = {
 		[TC_UNAME_R] = "4.4.4",
@@ -130,6 +127,9 @@ static noreturn int depmod_search_order_same_prefix(const struct test *t)
 	exit(EXIT_FAILURE);
 }
 DEFINE_TEST(depmod_search_order_same_prefix,
+#if defined(KMOD_SYSCONFDIR_NOT_ETC)
+	.skip = true,
+#endif
 	.description = "check if depmod honor search order in config with same prefix",
 	.config = {
 		[TC_UNAME_R] = "4.4.4",
@@ -156,9 +156,6 @@ static noreturn int depmod_detect_loop(const struct test *t)
 	exit(EXIT_FAILURE);
 }
 DEFINE_TEST(depmod_detect_loop,
-#if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
-#endif
 	.description = "check if depmod detects module loops correctly",
 	.config = {
 		[TC_UNAME_R] = "4.4.4",
@@ -183,7 +180,7 @@ static noreturn int depmod_search_order_external_first(const struct test *t)
 }
 DEFINE_TEST(depmod_search_order_external_first,
 #if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
+	.skip = true,
 #endif
 	.description = "check if depmod honor external keyword with higher priority",
 	.config = {
@@ -211,6 +208,9 @@ static noreturn int depmod_search_order_external_last(const struct test *t)
 	exit(EXIT_FAILURE);
 }
 DEFINE_TEST(depmod_search_order_external_last,
+#if defined(KMOD_SYSCONFDIR_NOT_ETC)
+	.skip = true,
+#endif
 	.description = "check if depmod honor external keyword with lower priority",
 	.config = {
 		[TC_UNAME_R] = "4.4.4",
@@ -238,7 +238,7 @@ static noreturn int depmod_search_order_override(const struct test *t)
 }
 DEFINE_TEST(depmod_search_order_override,
 #if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
+	.skip = true,
 #endif
 	.description = "check if depmod honor override keyword",
 	.config = {
diff --git a/testsuite/test-modprobe.c b/testsuite/test-modprobe.c
index 3ddb976..6b763d8 100644
--- a/testsuite/test-modprobe.c
+++ b/testsuite/test-modprobe.c
@@ -84,7 +84,7 @@ static noreturn int modprobe_show_alias_to_none(const struct test *t)
 }
 DEFINE_TEST(modprobe_show_alias_to_none,
 #if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
+	.skip = true,
 #endif
 	.description = "check if modprobe --show-depends doesn't explode with an alias to nothing",
 	.config = {
@@ -176,7 +176,7 @@ static noreturn int modprobe_softdep_loop(const struct test *t)
 }
 DEFINE_TEST(modprobe_softdep_loop,
 #if defined(KMOD_SYSCONFDIR_NOT_ETC)
-        .skip = true,
+	.skip = true,
 #endif
 	.description = "check if modprobe breaks softdep loop",
 	.config = {
@@ -200,6 +200,9 @@ static noreturn int modprobe_install_cmd_loop(const struct test *t)
 	exit(EXIT_FAILURE);
 }
 DEFINE_TEST(modprobe_install_cmd_loop,
+#if defined(KMOD_SYSCONFDIR_NOT_ETC)
+	.skip = true,
+#endif
 	.description = "check if modprobe breaks install-commands loop",
 	.config = {
 		[TC_UNAME_R] = "4.4.4",
diff --git a/testsuite/test-new-module.c b/testsuite/test-new-module.c
index 9872b78..dcb9934 100644
--- a/testsuite/test-new-module.c
+++ b/testsuite/test-new-module.c
@@ -106,6 +106,9 @@ static int from_alias(const struct test *t)
 	return EXIT_SUCCESS;
 }
 DEFINE_TEST(from_alias,
+#if defined(KMOD_SYSCONFDIR_NOT_ETC)
+	.skip = true,
+#endif
 	.description = "check if aliases are parsed correctly",
 	.config = {
 		[TC_ROOTFS] = TESTSUITE_ROOTFS "test-new-module/from_alias/",